#!/bin/bash
file=$1
newpart=$2

#Get first line of replacement part.
line1=`head -n 1 $newpart`;
#echo "Token from $rp: $line1";

#Find indices of all lines in $file ($tt) with the same content.
aaTmp=`cat $file | grep -n "$line1" | grep -o -E "^[0-9]+"`;
oldIFS=$IFS4
# The following make string handling split on new line character.
IFS='
'
#Transforms aaTmp into an array using $IFS.
aa=($aaTmp);
IFS=$oldIFS
##echo "In $file found at line: ${aa[@]}";

#Test if array is empty.
if ((${#aa[@]} < 1)); then
  echo "Replace location not found";
  exit 1;
fi

#Test if array contains more than 1 element.
if ((${#aa[@]} > 1)); then
  echo "More than 1 replace location not found";
  exit 2;
fi

#Find indices of comments and empty lines from $file ($tt).
bbTmp=`cat $file | grep -n -E "^#|^ *$" | grep -o -E "^[0-9]+"`; 
IFS='
'
#Transforms bbTmp into an array using $IFS.
bb=($bbTmp);                           
IFS=$oldIFS
#
##echo "Comments & blank lines: ${bb[@]}"

#Search for next block start after our target block.
bbIndex=0
for ((i=0 ; i <  ${#bb[@]} ; i++))
do
  if ((${bb[$i]} > $aa)); then
    bbIndex=$i;
    break;
  fi
done
#echo "1st bigger index: $bbIndex (${bb[$bbIndex]} > $aa)";

#Check block were are going to replace has the expected size.
diff=$((${bb[$bbIndex]}-$aa));
newsize=`wc $newpart|sed "s/^ *\([0-9]*\).*/\1/"`
  ##echo "size = $newsize"

## assemble the parts in a temporary file
tempfile=`mktemp tempXXXXXX`   # get temp file
trap "rm -f $tempfile" 0         # and clean it when done

head -n `expr $aa - 1` $file > $tempfile
cat $newpart >> $tempfile
tail -n +${bb[$bbIndex]} $file >> $tempfile

## overwrite original file
mv $tempfile $file
